Core - Bug # 62001

Status: Resolved Priority: Should have
Author: Tymoteusz Motylewski Category:

Created: 2014-10-02 Assigned To:

Updated: 2014-10-07 Due date:

TYPO3 Version: 7

PHP Version:

Complexity:

Is Regression: Yes

Sprint Focus:

Subject: [Regression] Can not add image to FAL field in Flexform

Description

commit cb6b7f519b54cec0d09f46966e5a8461f13e45e5

[TASK] Replace Prototype in inline record JS

Introduced a regression that FAL fields are not working in flexform any more.

How to reproduce:
1. download and install extension:

https://forge.typo3.org/attachments/download/26263/mediacenter.zip

2. put the "mediacenter” plugin on the page
3. try to attach some images to the FAL field.

Result:
Images will not show up under the "add file" button.

Related issues:

related to Core - Task # 58475: Change IRRE Javascript code to jQuery

Resolved

2014-05-04

Associated revisions

Revision 0a578709 - 2014-10-07 14:05 - Tymoteusz Motylewski

[BUGFIX] Make FAL work in the flexform field having dot in the name

Fixes regression introduced in 16599c3ce7eead493e2bfaa29312775bf1659ded69

During the change from prototype to jQuery few places missed

escaping of the dot in the id of the DOM node.

This patch fixes these places and also few other jQuery related bugs

E.g. we have to use "object.length” to test if jQuery selector

was found.

Resolves: #62001

Related: #58475

Releases: master

Change-Id: 19bb661c5bf58aa9b73106a1e48f2206465a8974e
Reviewed-on: http://review.typo3.0rg/33106

Reviewed-by: Georg Ringer <georg.ringer@gmail.com>

Tested-by: Georg Ringer <georg.ringer@gmail.com>

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>
Revision bf17a3f1 - 2014-12-01 14:47 - Roland Waldner

[BUGFIX] Escape element ID before used in jQuery selector

General information: to use any of the meta-characters as a

literal part of a jQuery selector, it must be escaped with
two backslashes: http://api.jquery.com/category/selectors/

Using IRRE (TCA type "inline") in Flexforms, TYPO3 may
generate HTML elements with IDs containing dots. Example:

id="data-104-tt_content-182-pi_flexform---data---fileSelection
---IDEF---settings.fileSelection.files---vDEF_records"

If you set "useSortable" and "endableControls.dragdrop” to 1
for an element in your Flexform configuration,
inline.createDragAndDropSorting(objectld) will get called for
that element. This objectld has to be escaped to be used as a
literal part of a jQuery selector later in this function.

Otherwise the drag-and-drop functionality will fail.

Resolves: #62676

Related: #62001

Releases: 6.2

Change-Id: 1353a699d82885b7bd57d0dc5fafbb8f5646d693f
Reviewed-on: http://review.typo3.org/33777

Reviewed-by: Stefan Busemann <stefan.busemann@in2code.de>

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>

Reviewed-by: Alexander Opitz <opitz.alexander@googlemail.com>

Tested-by: Alexander Opitz <opitz.alexander@googlemail.com>

Revision 609fa966 - 2014-12-08 10:24 - Alexander Opitz

[BUGFIX] Follow up: Escape element ID before used in jQuery selector

Resolves: #62676

Related: #62001

Releases: 6.2

Change-Id: 150b1e24159ad79174a12f3b5130e1bfd8e77e8a5
Reviewed-on: http://review.typo3.org/34874

Reviewed-by: Stefan Neufeind <typo3.neufeind@speedpartner.de>

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Reviewed-by: Oliver Hader <oliver.hader@typo3.org>

Tested-by: Oliver Hader <oliver.hader@typo3.org>

History

#1 - 2014-10-02 11:03 - Tymoteusz Motylewski

seems the problem is around line 486
the patch changed line:

new Insertion.Bottom(insertObject, htmlIData);

to
TYPOS.jQuery('# + insertObject).append(htmiData);

and "insertObject" is sth like "data-52-tt_content-272-pi_flexform---data---sDEF---IDEF---settings.mediacenter---vDEF_records"

and YES, there is a div with this exact id (including the dot in the id)
the dot is comming from the field name "settings.mediacenter"

the problem is that the dot "." is interpreted differently between prototype and jquery.
prototype just passes it to "getElementByld" so it's ok to have a dot.
But jquery thinks this dot is a class selector.

The solution:

Escape dot before passing it to the jquery.

#2 - 2014-10-02 14:16 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/33106

#3 - 2014-10-02 14:37 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/33106

#4 - 2014-10-03 01:13 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/33106

#5 - 2014-10-07 14:30 - Tymoteusz Motylewski
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:0a578709478ede8506b7d3216f553ad80605728d.
